function init()
    flying = false
    speed = 8
    customSpeed = 1
    lastScroll = -1
    a = 0
end

function tick(dt)
    if InputPressed("v") then
        flying = not flying
    end

    if flying then
        dir = Vec(0, 0, 0)

        if(InputDown("up")) then
            dir[3] = -1
        end

        if(InputDown("down")) then
            dir[3] = 1
        end

        if(InputDown("left")) then
            dir[1] = -1
        end

        if(InputDown("right")) then
            dir[1] = 1
        end
        
        dir = TransformToParentVec(GetCameraTransform(), Vec(dir[1], 0, dir[3]))
        
        if(InputDown("space")) then
            dir[2] = 1
        end

        if(InputDown("ctrl")) then
            dir[2] = -1
        end

        if(InputDown("shift")) then
            scroll = InputValue("mousewheel")

            if math.abs(scroll) > 0 then
                lastScroll = GetTime()
                customSpeed = math.clamp(customSpeed + scroll, 1, 10)
            end
            
            speed = 15 + customSpeed * customSpeed
        else
            speed = 8
        end

        if(VecLength(dir) > 0) then
            dir = VecNormalize(dir)
        end
        
        velocity = VecScale(dir, speed)
        velocity[2] = velocity[2] + 0.166666698455811

        SetPlayerVelocity(velocity)
    end
end

function draw(dt)
	if GetTime() < (lastScroll + 1) then
        a = math.lerp(a, 1, 15 * dt)
    else
        a = math.lerp(a, 0, 15 * dt)
    end

    if a > 0.0001 then
        UiPush()
            UiTranslate(UiCenter(), 100, 0)
            UiScale(0.75 + a / 4)
            UiAlign("center middle")
            UiColor(1, 1, 1, a * 0.5)
            UiFont("bold.ttf", 18)
            UiText("FLY SPEED "..customSpeed)
        UiPop()
    end
end

function math.clamp(num, min, max)
	if num < min then
		num = min
	elseif num > max then
		num = max    
	end
	
	return num
end

function math.lerp(from, to, t)
	return from + (to - from) * math.clamp(t, 0, 1)
end
